#!/usr/local/bin/pythonw -t

# evolved organically.


from slithy import *
from myslithy import *
from mapping import mapping_sequence, city_level_sequence, mapping_sequence_2_background, mapping_sequence_2_trs
from overload import overload_sequence
from auth import auth_sequence
# from mf import *
# from chirp1 import *
# from capac import *
# from hardstuff import *
#from mapping import mapping_sequence, city_level_sequence, mapping_sequence_2_background, mapping_sequence_2_trs
from resources import font
from images import thumb_slide,png
#from inflation import inflation_quick, inflation_metrics_sequence, peering_inference_walkthrough, diversity_sequence
#from hardstuff import policy_slide
#from worlds import worlds_sequence
#from reduction import reduction_sequence
#from peering import peering_intro_sequence
#from find_design import new_find_design_sequence,springfield

import Image
import PngImagePlugin

play(thumb_slide(1))

play(title_slide(title="Accountability as a Service",
                 # subtitle="Myths, Realities, and Best Practices",
                 author=[ "Adam Bender, ", yellow, "Neil Spring, ", RESETCOLOR, "\nDave Levin, Bobby Bhattacharjee\n\n", "University of Maryland" ],
                 date="SRUTI 2007",
                 titlesize=29,
                 subtitlesize=24))

pause()

# play(auth_sequence())

play(overload_sequence())

# play(bullet_slide(title="IP Addresses are Overloaded",
#                   bullets=[ 
#                             "* End-to-end reachability",
#                             "* Load balancing",
#                             "* Geographically targeted ads",
#                             "* Authorization (libraries)",
#                             "* Accountability",
#                             "** Idenitifies the organization that injected the traffic",
#                             "** ISPs and countries with hooligans disconnected or blacklisted (RBL)",
#                             ]))

play(bullet_slide(title="Overloading IP addrs is bad",
                  bullets=[ "* Free networks are troublesome",
                            "** I could provide connectivity, but...",
                            "** I can't take responsibility for the traffic",
                            "* Overlay network are troublesome",
                            "** I would like to relay other users' traffic in exchange for having mine relayed",
                            "** I'd have to spoof the original IP address (forbidden)",
                            "** or I'd have to NAT and accept responsibility",
                            "* Not to mention mobile networks",
                            ]))

play(bullet_slide(title="But Wait! That Sucks!",
                  bullets=[
    "* We want (and deploy) free networks",
    "** municipal",
    "** in hotels",
    "** in plazas",
    "** in coffee shops",
    "* We want (and expect) overlay networks",
    "** BGP will be with us forever",
    "* We want to support mobility",
    "** Latency may matter more as bandwidth increases",
]))

play(bullet_slide(title="Traceback isn't accountability",
                  titlesize=24,
                  bulletsize=20,
                  bullets=[
    "If the source address isn't spoofed",
    "* traceback isn't needed.",
    "If the source address is spoofed",
    "* it's from an ISP that doesn't care.",
    # work here on defn.
    "Accountability:",
    "* Disconnect the bad guys.",
    "* Sue the really bad guys.",
    "* Let everyone else be.",
] ))

# play(bullet_slide(title="The Problem",
#                   bullets=[
#     "Can't provide connectivity without \"vouching for\" traffic.",
#     "* Non-technical limit to ubiquitous networks",
#     "Must prevent \"unaccountable\" traffic",
#     "* Today, that means preventing spoofing",
#     "* Elimintates a space of valid but \"dangerous\" designs",
# ]))

play(bullet_slide(title="Let's Review",
                  bulletsize=16,
                  bullets=[
    "In Theory:",
    "* Addressing (where) is the network layer's job",
    "* Accountability (who) is the application's job",
    "In Practice:",
    "* Accountability derives from addressing, because authentication is late",
    "** logs record getpeername",
    "** abuse reports flow toward source addresses",
    "** firewalls match on addresses",
    "* Can't provide connectivity without \"vouching for\" traffic.",
    # "* Non-technical limit to ubiquitous networks",
    "* Prevent spoofing to prevent \"unaccountable\" traffic.",
    # "* Elimintates a space of valid but \"dangerous\" designs.",
    # "Note: This is because network links are finite resources.",
]))

play(bullet_slide(title="Goal: Separate accnt. from addr.",
                  titlesize=24,
                  bulletsize=20,
                  bullets=[
    "* Trusted third party(ies) are matchmakers",
    "* Certificates tell destinations 'who' the sender is",
    "** May be opaque (e.g., discoverable by subpoena)",
    "** May be descriptive (e.g., over 18)",
    "** May be transparent (identifying)",
    "* Transmitted packets are 'signed'",
    "* Addresses guide routing, but are ignored in logging",
]))


play(auth_sequence(title="Basic Walkthrough")) 
# play(bullet_slide(title="Accountability Services (1/3)",
                  # bulletsize=20,
                  # bullets=[
    # "Take small payment for an account",
    # "* Users and servers are both clients of the accountability service",
    # "** Users send accountable traffic to avoid being confused for DDoS",
    # "** Servers send accountable traffic to (help) avoid phishing",
    # "* Process may vary, may require ID, or credit card, or very little",
# ]))
# 
# play(bullet_slide(title="Accountability Services (2/3)",
                  # bulletsize=20,
                  # bullets=[
    # "Distribute identifiers to authenticated users",
    # "* Identifiers expire, may be short-lived",
    # "* Identifiers may have public information",
# ]))
# 
# play(bullet_slide(title="Accountability Services (3/3)",
                  # bulletsize=20,
                  # bullets=[
    # "Accept abuse reports from clients",
    # "* With signed packets, identifiers",
    # "* Help to block further traffic",
# ]))

play(bullet_slide(title="Advanced (1/2)",
                  bullets=[
    "Firewalls block:",
    "* unsigned or mis-signed packets",
    "* packets from (bearing) blacklisted identifiers", # for timescales too short for help from the service
    "Keep unaccountable traffic off links",
    ]))

play(bullet_slide(title="Advanced (2/2)",
                  bullets=[
    "First-hop routers verify client signatures",
    "First-hop ISPs add packet passports",
    "* Asserts that the signature has been verified",
    "* Prevents overwhelming destination firewalls and intermediate links with bad signatures",
    "* ISPs can put pressure on each other to verify",
]))

play(bullet_slide(title="Advantages (1/2)",
                  bullets=[
    "Can choose what accountability (identification) a service expects",
    "* Lots: Are you really my customer?",
    "* Some: Track abusive anonymous posters",
    "* Little: Should we know who is interested in controversial topics or health conditions?",
    "If destinations don't require accountability, they shouldn't report abuse",
]))
play(bullet_slide(title="Advantages (2/2)",
                  bullets=[
    "Can choose the anonymity users desire",
    "* Decide what not to browse",
    "* Use other techniques (TOR) to launder (still accountable) traffic through intermediate proxies",
    "No ambiguity.",
]))
    

play(bullet_slide(title="Disadvantages",
                  bulletsize=22,
                  bullets=[
    "Per-packet cost",
    "* May be reduced by negotiating more compact shared secrets",
    "Early authentication",
    "* Disconnected operation requires disabling accountability or a local service",
    "Puts cryptography in the network",
    "* Could be shifted to edges",
    ]))

play(bullet_slide(title="Standard Questions",
                  bulletsize=18,
                  bullets=[
    "What about botnets?",
    "* Subverted machines may be detected and blocked like bad credit cards", # steal the keys, it may be observed.
    "* Destinations have leverage to disconnect bad senders ISPs don't",
    "What about deployment?",
    "* Likely-target services may expect more accountability",
    "** Discard or throttle unaccountable traffic",
    "** Anywhere security is more important than universal access",
    "* Free networks may serve only those who do not have to be policed",
    ]))

play(bullet_slide(title="Ecology of Accountability",
                  bulletsize=16,
                  bullets=[
    # this is the part I think most interesting, most open
    "What will users do?",
    "* Sacrifice as little privacy as possible?",
    "What will servers do?",
    "* Require more or less information about clients?",
    "What will intruders do?",
    "* Steal keys? passwords?",
    "What will developers do?",
    "* Rely on accountability for authorization (I hope not)",
    "What will accountability services charge?",
    "* Service pays? (like credit cards?)",
    "* Subsidized through other revenue (like google services?)",
]))
    
    
    
play(bullet_slide(title="Summary",
                  bulletsize=22,
                  bullets=[
    "*Accountability must be decoupled from addressing",
    "** As a first-class network service",
    "*Get the network out of the accountability vs. anonymity tussle",
    "** Though network operators do a good job now",
    "*Destinations should have leverage to disconnect bad senders",
    ]))
    

pause()

run_presentation(screen_size=(1024,768))
#run_presentation(screen_size=(800,600))
#run_presentation(screen_size=(640,480))
exit


